#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "define.h"
#include "buffer.h"

#include "rand.h"

static void showfile(char *filename);
static int openfile(char * sFilename, char * sMode);
static void closefile(void);
static int getline(char *s);

static FILE *stream = NULL;

/* static bool bFlag = FALSE; */        /* Prevent multiple file opens */

void
intro(void)
{
  string sTemp;

  printf ("\n\n");
  printf (" *************************************\n");
  printf (" *                                   *\n");
  printf (" *                                   *\n");
  printf (" *      * * Super Star Trek * *      *\n");
  printf (" *                                   *\n");
  printf (" *                                   *\n");
  printf (" *************************************\n\n\n\n\n");

  printf("\nDo you need instructions (y/n): ");

  /* gets(sTemp); */
  fgets(sTemp,sizeof(sTemp),stdin);

  if (sTemp[0] == 'y' || sTemp[0] == 'Y')
    showfile("startrek.doc");

  printf ("\n\n\n\n\n\n\n");
  printf("                         ------*------\n");
  printf("         -------------   `---  ------'\n");
  printf("         `-------- --'      / /\n");
  printf("                  \\\\-------  --\n");
  printf("                  '-----------'\n");
  printf("\n       The USS Enterprise --- NCC - 1701\n\n\n");

  /* randomize(); */
  randomize2();

  t = (get_rand(20) + 20) * 100;
}

static void
showfile(char *filename)
{
  line lBuffer;
  int iRow = 0;

  if (openfile(filename, "r") != 0)
    return;

  while (getline(lBuffer) != 0)
    {
      printf(lBuffer);

      if (iRow++ > MAXROW - 3)
        {
          getchar();
          iRow = 0;
        }
    }

  closefile();
}

static int
openfile(char * sFilename, char * sMode)
{
  /* if (bFlag || (stream = fopen (sFilename, sMode)) == NULL) */
  if ( stream || (stream = fopen (sFilename, sMode)) == NULL)
    {
      fprintf (stderr, "\nError - Unable to open file: %s.\n\n", sFilename);
      return 1 ;
    }
  /* bFlag = TRUE; */
  return 0;
}

static void
closefile(void)
{
  /* if (! bFlag) */
  if (stream)
    fclose(stream);

  /* bFlag = FALSE; */
  stream = NULL;
}

static int
getline(char *s)
{
  if (fgets(s, MAXCOL, stream) == NULL)
    return(0);
  else
    return(strlen(s));
}
